Index: /mods/wpsg_mod_export.class.php
===================================================================
--- /mods/wpsg_mod_export.class.php	(revision 7799)
+++ /mods/wpsg_mod_export.class.php	(revision 7804)
@@ -877,839 +877,842 @@
                             OP.`o_id` = '".wpsg_q($order_id)."'
                     ");
-                    
+
                     foreach ($arProdukte as $p)
                     {
-                    
+
                         $row = array();
-                        
+
                         foreach ($profil['fields'] as $f)
                         {
 
                             $row[] = $this->getValue($f, $profil['field_delimiter'], $order_id, $p['p_id'], $p['product_index'], $p['productkey'], $p['order_product_id']);
-                                                                
+
                         }
 
-                        $arExportData[] = $row; 
-                        
-                    }
-                    
-                }
-	
-				if (\memory_get_usage() > 200000) {
-		
-					$this->arCache = [];
-		
-				}
-	
-				wpsg_product::clearCache();
-				wpsg_order::clearCache($order_id);
-				wpsg_customer::clearCache();
-				wpsg_order_product::clearCache();
-	
-				$this->shop->cache->clearOrderCache(false);
-				$this->shop->cache->clearProductCache(false);
-				$this->shop->cache->clearKundenCache(false);
-	
-				gc_collect_cycles ();
-	
-			} // foreach arData
-             
+                        $arExportData[] = $row;
+
+                    }
+
+                }
+
+                if (\memory_get_usage() > 200000) {
+
+                    $this->arCache = [];
+
+                }
+
+                wpsg_product::clearCache();
+                wpsg_order::clearCache($order_id);
+                wpsg_customer::clearCache();
+                wpsg_order_product::clearCache();
+
+                $this->shop->cache->clearOrderCache(false);
+                $this->shop->cache->clearProductCache(false);
+                $this->shop->cache->clearKundenCache(false);
+
+                gc_collect_cycles ();
+
+            } // foreach arData
+
             foreach ($arExportData as $row)
             {
-                
+
                 fputcsv($filehandler, $row, $profil['field_delimiter'], $profil['field_enclosure'], $profil['field_escape']);
-                                    
-            }
-            
+
+            }
+
             fclose($filehandler);
-            
+
             // In ISO wandeln
             if ($profil['file_encoding'] == self::ENCODING_ISO88591)
             {
-                
+
                 file_put_contents($tmpfname, utf8_decode(file_get_contents($tmpfname)));
-                                        
-            }
-                        
+
+            }
+
             return $tmpfname;
-            			
-		} // private function handleExportCSV($arProfile, $arOrderFilter = array(), $cron = false)
-
-		/**
-		 * Erstellt die CSV und gibt den Pfad zur erstellten Datei zurÃŒck (FÃŒr einen Aboexport)
-		 * 
-		 * 
-		 */
-		private function handleExportAboCSV() 
-		{
-			
-			//TODO
-			
-		}
-		
-		/**
-		 * Erstellt die CSV und gibt den Pfad zur erstellten Datei zurÃŒck (FÃŒr einen Kundenexport)
-		 * 
-		 * @param $profil_id
-		 * @param array $arOrderFilter
-		 */
-		private function handleExportCustomerCSV($profil_id, $arCustomerFilter = array())
-		{
-			
-			$this->loadFields(); 
-			
-			$arData = wpsg_customer::find($arCustomerFilter); 
+
+        } // private function handleExportCSV($arProfile, $arOrderFilter = array(), $cron = false)
+
+        /**
+         * Erstellt die CSV und gibt den Pfad zur erstellten Datei zurÃŒck (FÃŒr einen Aboexport)
+         *
+         *
+         */
+        private function handleExportAboCSV()
+        {
+
+            //TODO
+
+        }
+
+        /**
+         * Erstellt die CSV und gibt den Pfad zur erstellten Datei zurÃŒck (FÃŒr einen Kundenexport)
+         *
+         * @param $profil_id
+         * @param array $arOrderFilter
+         */
+        private function handleExportCustomerCSV($profil_id, $arCustomerFilter = array())
+        {
+
+            $this->loadFields();
+
+            $arData = wpsg_customer::find($arCustomerFilter);
 
             $tmpfname = tempnam($this->getTmpFilePath(), "wpsg");
             $filehandler = fopen($tmpfname, 'w');
-            
+
             $profil = $this->loadProfil($profil_id);
-            
+
             $arExportData = array();
-            
+
             if ($profil['csv_fieldnames'] == '1')
             {
-                
+
                 $row = array();
-                
+
                 foreach ($profil['fields'] as $f)
                 {
-                    
+
                     $row[] = $f['name'];
-                    
-                }
-                
+
+                }
+
                 $arExportData[] = $row;
-                
-            }
-            
-            foreach ($arData as $oCustomer) 
-            {
-                
-				$row = array();
-				                        
-				foreach ($profil['fields'] as $f)
-				{
-
-					$row[] = $this->getValue($f, $profil['field_delimiter'], false, false, 1, false, false, $oCustomer->id);
-														
-				}
-
-                $arExportData[] = $row; 
-                                
+
+            }
+
+            foreach ($arData as $oCustomer)
+            {
+
+                $row = array();
+
+                foreach ($profil['fields'] as $f)
+                {
+
+                    $row[] = $this->getValue($f, $profil['field_delimiter'], false, false, 1, false, false, $oCustomer->id);
+
+                }
+
+                $arExportData[] = $row;
+
             } // foreach arData
-             
+
             foreach ($arExportData as $row)
             {
-                
+
                 fputcsv($filehandler, $row, $profil['field_delimiter'], $profil['field_enclosure'], $profil['field_escape']);
-                                    
-            }
-            
+
+            }
+
             fclose($filehandler);
-            
+
             // In ISO wandeln
             if ($profil['file_encoding'] == self::ENCODING_ISO88591)
             {
-                
+
                 file_put_contents($tmpfname, utf8_decode(file_get_contents($tmpfname)));
-                                        
-            }
-                        
+
+            }
+
             return $tmpfname;
-			
-		} // private function handleExportCustomerCSV($profil_id, $arOrderFilter = array())
-		
-		/**
-		 * Erstellt die XML und gibt den Pfad zur erstellten Datei zurÃŒck (FÃŒr einen Produktexport)
-		 * 
-		 * @param $profil_id
-		 * @param array $arProductFilter
-		 * @return string
-		 * @throws Exception
-		 */
-		private function handleExportProductXML($profil_id, $arProductFilter = array())
-		{
-			
-			$this->loadFields();
-			
-			$arData = wpsg_product::find($arProductFilter);
-			$profil = $this->loadProfil($profil_id);
-			
-			if (!wpsg_isSizedString($profil['xml_roottag'])) throw new \Exception(wpsg_translate(__('Kein XML Root Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
-			if (!wpsg_isSizedString($profil['xml_producttag'])) throw new \Exception(wpsg_translate(__('Kein XML Produkt Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
-			
-			$doc = new DOMDocument('1.0');
+
+        } // private function handleExportCustomerCSV($profil_id, $arOrderFilter = array())
+
+        /**
+         * Erstellt die XML und gibt den Pfad zur erstellten Datei zurÃŒck (FÃŒr einen Produktexport)
+         *
+         * @param $profil_id
+         * @param array $arProductFilter
+         * @return string
+         * @throws Exception
+         */
+        private function handleExportProductXML($profil_id, $arProductFilter = array())
+        {
+
+            $this->loadFields();
+
+            $arData = wpsg_product::find($arProductFilter);
+            $profil = $this->loadProfil($profil_id);
+
+            if (!wpsg_isSizedString($profil['xml_roottag'])) throw new \Exception(wpsg_translate(__('Kein XML Root Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
+            if (!wpsg_isSizedString($profil['xml_producttag'])) throw new \Exception(wpsg_translate(__('Kein XML Produkt Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
+
+            $doc = new DOMDocument('1.0');
             $doc->formatOutput = true;
-            
-            $root = $doc->createElement($this->clearXML($profil['xml_roottag']));					
+
+            $root = $doc->createElement($this->clearXML($profil['xml_roottag']));
             $root = $doc->appendChild($root);
-			
-			foreach ($arData as $oProduct)
-            {
-                
+
+            foreach ($arData as $oProduct)
+            {
+
                 $tag_product = $doc->createElement($this->clearXML($profil['xml_producttag']));
                 $tag_product = $root->appendChild($tag_product);
-			
-				foreach ($profil['fields'] as $f)
-                {
-                    
+
+                foreach ($profil['fields'] as $f)
+                {
+
                     $value = $this->getValue($f, $profil['field_delimiter'], false, $oProduct->id);
-                                                    
-					if (wpsg_isSizedInt($f['xml_att']))
-					{
-						
-						$att = $doc->createAttribute($this->clearXML($f['name']));
-						$att->value = htmlspecialchars($value);
-						
-						$tag_product->appendChild($att);
-
-						
-					}
-					else
-					{
-						
-						$tag = $doc->createElement($this->clearXML($f['name']));
-						$tag = $tag_product->appendChild($tag);
-						
-						$tag_value = $doc->createTextNode(htmlspecialchars($value));
-						$tag->appendChild($tag_value);
-						
-					}
-                                         
-                }
-				
-			}
-			
-			$tmpfname = tempnam($this->getTmpFilePath(), "wpsg");
+
+                    if (wpsg_isSizedInt($f['xml_att']))
+                    {
+
+                        $att = $doc->createAttribute($this->clearXML($f['name']));
+                        $att->value = htmlspecialchars($value);
+
+                        $tag_product->appendChild($att);
+
+
+                    }
+                    else
+                    {
+
+                        $tag = $doc->createElement($this->clearXML($f['name']));
+                        $tag = $tag_product->appendChild($tag);
+
+                        $tag_value = $doc->createTextNode(htmlspecialchars($value));
+                        $tag->appendChild($tag_value);
+
+                    }
+
+                }
+
+            }
+
+            $tmpfname = tempnam($this->getTmpFilePath(), "wpsg");
             file_put_contents($tmpfname, $doc->saveXML());
-            
+
             // In ISO wandeln
             if ($profil['file_encoding'] == self::ENCODING_ISO88591)
             {
-                
+
                 file_put_contents($tmpfname, utf8_decode(file_get_contents($tmpfname)));
-                                        
-            }
-            
+
+            }
+
             return $tmpfname;
-			
-		} // private function handleExportProductXML($profil_id, $arProductFilter = array())
-		
+
+        } // private function handleExportProductXML($profil_id, $arProductFilter = array())
+
         /**
          * Erstellt die XML und gibt den Pfad zur erstellten Datei zurÃŒck (FÃŒr einen Bestellexport)
-         * 
+         *
          * @param $arProfile
          * @param array $arOrderFilter
          */
-		private function handleExportXML($profil_id, $arOrderFilter = array())
-		{
-			
-			$this->loadFields();
-			
-			$arData = wpsg_order::find($arOrderFilter); 
-												
+        private function handleExportXML($profil_id, $arOrderFilter = array())
+        {
+
+            $this->loadFields();
+
+            $arData = wpsg_order::find($arOrderFilter);
+
             $profil = $this->loadProfil($profil_id);
-            
+
             if (!wpsg_isSizedString($profil['xml_roottag'])) throw new \Exception(wpsg_translate(__('Kein XML Root Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
             if (!wpsg_isSizedString($profil['xml_ordertag'])) throw new \Exception(wpsg_translate(__('Kein XML Bestellung Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
             if (!wpsg_isSizedString($profil['xml_productroottag'])) throw new \Exception(wpsg_translate(__('Kein XML Produkt Roottagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
             if (!wpsg_isSizedString($profil['xml_producttag'])) throw new \Exception(wpsg_translate(__('Kein XML Produkt Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
-            
+
             $doc = new DOMDocument('1.0');
             $doc->formatOutput = true;
-            
-            $root = $doc->createElement($this->clearXML($profil['xml_roottag']));					
+
+            $root = $doc->createElement($this->clearXML($profil['xml_roottag']));
             $root = $doc->appendChild($root);
-            
+
             foreach ($arData as $oOrder)
             {
-                
+
                 $tag_order = $doc->createElement($this->clearXML($profil['xml_ordertag']));
                 $tag_order = $root->appendChild($tag_order);
-                 
-                $tag_product_root = false; 
-                
+
+                $tag_product_root = false;
+
                 if (wpsg_isSizedString($profil['xml_productroottag']))
                 {
-                    
+
                     $tag_product_root = $doc->createElement($this->clearXML($profil['xml_productroottag']));
                     $tag_product_root = $tag_order->appendChild($tag_product_root);
-                                                
-                }
-                
+
+                }
+
                 foreach ($profil['fields'] as $f)
                 {
-                    
+
                     // Wert ist kein Produktfeld
                     if ($this->getFieldGroup($f['value_key']) != 20)
                     {
-                        
+
                         $value = $this->getValue($f, $profil['field_delimiter'], $oOrder->id);
-                                                    
+
                         if (wpsg_isSizedInt($f['xml_att']))
                         {
-                            
+
                             $att = $doc->createAttribute($this->clearXML($f['name']));
                             $att->value = htmlspecialchars($value);
-                            
+
                             $tag_order->appendChild($att);
 
-                            
+
                         }
                         else
                         {
-                            
+
                             $tag = $doc->createElement($this->clearXML($f['name']));
                             $tag = $tag_order->appendChild($tag);
-                            
+
                             $tag_value = $doc->createTextNode(htmlspecialchars($value));
                             $tag->appendChild($tag_value);
-                            
+
                         }
-                        
-                    }
-                    
-                }
-                
+
+                    }
+
+                }
+
                 // Produkte
                 $arOrderProducts = $oOrder->getOrderProducts();
-                
+
                 foreach ($arOrderProducts as $oOrderProduct)
                 {
-                    
+
                     $tag_product = false;
-                    
+
                     foreach ($profil['fields'] as $f)
                     {
-                                                        
+
                         // Wert ist ein Produktfeld
                         if ($this->getFieldGroup($f['value_key']) == 20)
                         {
-                                        
+
                             if ($tag_product === false) $tag_product = $doc->createElement($this->clearXML($profil['xml_producttag']));
-                            
+
                             $value = $this->getValue($f, $profil['field_delimiter'], $oOrder->id, $oOrderProduct->getProductId(), $oOrderProduct->getProductIndex(), $oOrderProduct->getProductKey());
-                        
+
                             if (wpsg_isSizedInt($f['xml_att']))
                             {
-                                
+
                                 $att = $doc->createAttribute($this->clearXML($f['name']));
                                 $att->value = htmlspecialchars($value);
-                                
+
                                 $tag_product->appendChild($att);
 
-                                
+
                             }
                             else
                             {
-                                
+
                                 $tag = $doc->createElement($this->clearXML($f['name']));
                                 $tag = $tag_product->appendChild($tag);
-                                
+
                                 $tag_value = $doc->createTextNode(htmlspecialchars($value));
                                 $tag->appendChild($tag_value);
-                                
+
                             }
-                            
+
                         }
                     }
-                    
+
                     if ($tag_product !== false)
                     {
-                        
+
                         $tag_product_root->appendChild($tag_product);
-                        
-                    }
-                    
+
+                    }
+
                 } // foreach Produkte
-                 
+
             } // foreach Order
-            
+
             $tmpfname = tempnam($this->getTmpFilePath(), "wpsg");
             file_put_contents($tmpfname, $doc->saveXML());
-            
+
             // In ISO wandeln
             if ($profil['file_encoding'] == self::ENCODING_ISO88591)
             {
-                
+
                 file_put_contents($tmpfname, utf8_decode(file_get_contents($tmpfname)));
-                                        
-            }
-            
+
+            }
+
             return $tmpfname;
-              			
-		} // private function handleExportXML($arProfile, $arOrderFilter = array(), $cron = false)
-
-		/**
-		 * Erstellt die XML und gibt den Pfad zur erstellten Datei zurÃŒck (FÃŒr einen Kundenexport)
-		 * 
-		 * @param $profil_id
-		 * @param array $arOrderFilter
-		 */
-		private function handleExportCustomerXML($profil_id, $arCustomerFilter = array()) 
-		{
-			
-			$this->loadFields();
-			
-			$arData = wpsg_customer::find($arCustomerFilter);
-			$profil = $this->loadProfil($profil_id);
-			
-			if (!wpsg_isSizedString($profil['xml_roottag'])) throw new \Exception(wpsg_translate(__('Kein XML Root Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
-			if (!wpsg_isSizedString($profil['xml_producttag'])) throw new \Exception(wpsg_translate(__('Kein XML Kunden Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
-			
-			$doc = new DOMDocument('1.0');
+
+        } // private function handleExportXML($arProfile, $arOrderFilter = array(), $cron = false)
+
+        /**
+         * Erstellt die XML und gibt den Pfad zur erstellten Datei zurÃŒck (FÃŒr einen Kundenexport)
+         *
+         * @param $profil_id
+         * @param array $arOrderFilter
+         */
+        private function handleExportCustomerXML($profil_id, $arCustomerFilter = array())
+        {
+
+            $this->loadFields();
+
+            $arData = wpsg_customer::find($arCustomerFilter);
+            $profil = $this->loadProfil($profil_id);
+
+            if (!wpsg_isSizedString($profil['xml_roottag'])) throw new \Exception(wpsg_translate(__('Kein XML Root Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
+            if (!wpsg_isSizedString($profil['xml_producttag'])) throw new \Exception(wpsg_translate(__('Kein XML Kunden Tagname fÃŒr Profil "#1#" gesetzt!', 'wpsg'), $profil['name']));
+
+            $doc = new DOMDocument('1.0');
             $doc->formatOutput = true;
-            
-            $root = $doc->createElement($this->clearXML($profil['xml_roottag']));					
+
+            $root = $doc->createElement($this->clearXML($profil['xml_roottag']));
             $root = $doc->appendChild($root);
-			
-			foreach ($arData as $oCustomer)
-            {
-                
+
+            foreach ($arData as $oCustomer)
+            {
+
                 $tag_product = $doc->createElement($this->clearXML($profil['xml_customertag']));
                 $tag_product = $root->appendChild($tag_product);
-			
-				foreach ($profil['fields'] as $f)
-                {
-                    
+
+                foreach ($profil['fields'] as $f)
+                {
+
                     $value = $this->getValue($f, $profil['field_delimiter'], false, false, 1, false, false, $oCustomer->id);
-                                                    
-					if (wpsg_isSizedInt($f['xml_att']))
-					{
-						
-						$att = $doc->createAttribute($this->clearXML($f['name']));
-						$att->value = htmlspecialchars($value);
-						
-						$tag_product->appendChild($att);
-
-						
-					}
-					else
-					{
-						
-						$tag = $doc->createElement($this->clearXML($f['name']));
-						$tag = $tag_product->appendChild($tag);
-						
-						$tag_value = $doc->createTextNode(htmlspecialchars($value));
-						$tag->appendChild($tag_value);
-						
-					}
-                                         
-                }
-				
-			}
-			
-			$tmpfname = tempnam($this->getTmpFilePath(), "wpsg");
+
+                    if (wpsg_isSizedInt($f['xml_att']))
+                    {
+
+                        $att = $doc->createAttribute($this->clearXML($f['name']));
+                        $att->value = htmlspecialchars($value);
+
+                        $tag_product->appendChild($att);
+
+
+                    }
+                    else
+                    {
+
+                        $tag = $doc->createElement($this->clearXML($f['name']));
+                        $tag = $tag_product->appendChild($tag);
+
+                        $tag_value = $doc->createTextNode(htmlspecialchars($value));
+                        $tag->appendChild($tag_value);
+
+                    }
+
+                }
+
+            }
+
+            $tmpfname = tempnam($this->getTmpFilePath(), "wpsg");
             file_put_contents($tmpfname, $doc->saveXML());
-            
+
             // In ISO wandeln
             if ($profil['file_encoding'] == self::ENCODING_ISO88591)
             {
-                
+
                 file_put_contents($tmpfname, utf8_decode(file_get_contents($tmpfname)));
-                                        
-            }
-            
+
+            }
+
             return $tmpfname;
-			
-		} // private function handleExportCustomerXML($profil_id, $arOrderFilter = array())
-						
-		/**
-		 * Bereinigt Daten an XML fÃŒr Tagname / Attributname
-		 */
-		private function clearXML($value)
-		{
-			
-			$value = preg_replace('/\040+/', '_', $value);
-			$value = preg_replace('/\"|\<|\>|\'/', '', $value);
-			
-			return htmlspecialchars($value);
-			
-		}
-		
-		private function getFieldGroup($key)
-		{
-			
-			if (!wpsg_isSizedArray($this->fields)) $this->loadFields();
-			
-			foreach ($this->fields as $group_key => $group)
-			{
-				
-				foreach ($group['fields'] as $field_key => $field_label)
-				{
-					
-					if ($field_key == $key) return $group_key;
-					
-				}
-				
-			}
-			
-			return false;
-			
-		}
-		
-		public function renderProfil($profil_id)
-		{
-			
-			$this->loadFields();
-												
-			$this->shop->view['profil'] = $this->loadProfil($profil_id);
-									
-			$this->shop->view['cdate_years'] = $this->db->fetchAssocField("SELECT DISTINCT DATE_FORMAT(`cdate`, '%Y') FROM `".WPSG_TBL_ORDER."` ORDER BY `cdate` ASC ");
-			if ($this->shop->hasMod('wpsg_mod_rechnungen')) $this->shop->view['invoicedate_years'] = $this->db->fetchAssocField("SELECT DISTINCT DATE_FORMAT(`datum`, '%Y') FROM `".WPSG_TBL_RECHNUNGEN."` WHERE `storno` = '0000-00-00' AND `gnr` = '' ORDER BY `datum` ASC ");
-			
-			$this->shop->view['arExportFormats'] = $this->arExportFormats;
-			$this->shop->view['arFileEncoding'] = $this->arFileEncoding;				
-			$this->shop->view['arFieldFormats'] = $this->arFieldFormats;
-			$this->shop->view['arCronTypes'] = $this->arCronTypes;
-			$this->shop->view['fields'] = $this->fields;
-			$this->shop->view['strFields'] = $this->renderFields($this->shop->view['profil']);
-			
-			return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_export/profil.phtml', false);
-			
-		} // public function renderProfil($profil_id)
-
-		/**
-		 * Zeichner die Felder des Profils
-		 * @param $profil_data
-		 */
-		function renderFields($profil_data)
-		{
-		
+
+        } // private function handleExportCustomerXML($profil_id, $arOrderFilter = array())
+
+        /**
+         * Bereinigt Daten an XML fÃŒr Tagname / Attributname
+         */
+        private function clearXML($value)
+        {
+
+            $value = preg_replace('/\040+/', '_', $value);
+            $value = preg_replace('/\"|\<|\>|\'/', '', $value);
+
+            return htmlspecialchars($value);
+
+        }
+
+        private function getFieldGroup($key)
+        {
+
             if (!wpsg_isSizedArray($this->fields)) $this->loadFields();
-            
-			$this->shop->view['arFieldFormats'] = $this->arFieldFormats;
-			$this->shop->view['fields'] = $this->fields;
-			$this->shop->view['profil'] = $profil_data;
-			
-			return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_export/fields.phtml', false);
-			
-		} // function renderFields($profil_data)
-		
-		/**
-		 * Gibt die Daten eines Profils zurÃŒck
-		 * @return Array Array mit den Profildaten
-		 * @param int $profil_id Die ID des zu ladenden Profils
-		 */
-		public function loadProfil($profil_id)
-		{
-			
-			$arReturn = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_EXPORTPROFILE."` WHERE `id` = '".wpsg_q($profil_id)."' ");
-			
-			$arReturn['orderfilter'] = @unserialize($arReturn['orderfilter']);			
-			if (!is_array($arReturn['orderfilter'])) $arReturn['orderfilter'] = array();
-						
-			$arReturn['fields'] = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `profil_id` = '".wpsg_q($profil_id)."' ORDER BY `pos` ASC, `id` ASC ", "id");
-			
-			if ($profil_id != wpsg_getInt($arReturn['id'])) throw new \Exception(__('Profil konnte nicht geladen werden.', 'wpsg'));
-			
-			return $arReturn;
-			
-		} // public function loadProfil($profil_id)
-		
-		private function loadFields()
-		{
-			
-			$this->fields = array(	
-				5 => array(
-					'name' => __('Allgemein', 'wpsg'),
-					'fields' => array(
-						'allgemein_empty' => __('Leer', 'wpsg'),
-						//'allgemein_statisch' => __('Statisch', 'wpsg'),
-						'allgemein_currency' => __('WÃ€hrung', 'wpsg')
-					)
-				),
-				10 => array(
-					'name' => __('Bestellung', 'wpsg'),
-					'fields' => array(
-						'order_id' => __('BestellID', 'wpsg'),
-						'order_cdate' => __('Erstellungsdatum', 'wpsg'),
-						'order_onr' => __('Bestellnummer', 'wpsg'),
-						'order_bemerkung' => __('Bemerkung Kunde', 'wpsg'),
-						'order_price' => __('Bestellsumme', 'wpsg'),
-						'order_price_netto' => __('Bestellsumme (Netto)', 'wpsg'),
-						'order_shipping' => __('Versandkosten', 'wpsg'),
-						'order_payment' => __('Kosten Bezahlmethode', 'wpsg'),
-						'order_useragent' => __('UserAgent', 'wpsg'),
-						'order_ip' => __('IP Adresse', 'wpsg'),						
-						
-						'order_invoice_title' => __('Rechnungsadresse Anrede', 'wpsg'),
-						'order_invoice_firma' => __('Rechnungsadresse Firma', 'wpsg'),
-						'order_invoice_vorname' => __('Rechnunsadresse Vorname', 'wpsg'),
-						'order_invoice_name' => __('Rechnungsadresse Name', 'wpsg'),						
-						'order_invoice_strasse' => __('Rechnungsadresse StraÃe (mit Hausnummer)', 'wpsg'),
-						'order_invoice_strasse_strasse' => __('Rechnungsadresse StraÃe (ohne Hausnummer)', 'wpsg'),
-						'order_invoice_strasse_nr' => __('Rechnungsadresse Hausnummer', 'wpsg'),
-						'order_invoice_plz' => __('Rechnungsadresse PLZ', 'wpsg'),
-						'order_invoice_ort' => __('Rechnungsadresse Ort', 'wpsg'),
-						'order_invoice_land' => __('Rechnungsadresse Land (Name)', 'wpsg'),
-						'order_invoice_land_krzl' => __('Rechnungsadresse Land (KÃŒrzel)', 'wpsg'),
-						'order_invoice_tel' => __('Rechnungsadresse Telefon', 'wpsg'),
-						'order_invoice_fax' => __('Rechnungsadresse Fax', 'wpsg'),
-									
-						'order_title' => __('Lieferadresse Anrede', 'wpsg'),
-						'order_firma' => __('Lieferadresse Firma', 'wpsg'),
-						'order_vorname' => __('Lieferadresse Vorname', 'wpsg'),
-						'order_name' => __('Lieferadresse Name', 'wpsg'),						
-						'order_strasse' => __('Lieferadresse StraÃe (mit Hausnummer)', 'wpsg'),
+
+            foreach ($this->fields as $group_key => $group)
+            {
+
+                foreach ($group['fields'] as $field_key => $field_label)
+                {
+
+                    if ($field_key == $key) return $group_key;
+
+                }
+
+            }
+
+            return false;
+
+        }
+
+        public function renderProfil($profil_id)
+        {
+
+            $this->loadFields();
+
+            $this->shop->view['profil'] = $this->loadProfil($profil_id);
+
+            $this->shop->view['cdate_years'] = $this->db->fetchAssocField("SELECT DISTINCT DATE_FORMAT(`cdate`, '%Y') FROM `".WPSG_TBL_ORDER."` ORDER BY `cdate` ASC ");
+            if ($this->shop->hasMod('wpsg_mod_rechnungen')) $this->shop->view['invoicedate_years'] = $this->db->fetchAssocField("SELECT DISTINCT DATE_FORMAT(`datum`, '%Y') FROM `".WPSG_TBL_RECHNUNGEN."` WHERE `storno` = '0000-00-00' AND `gnr` = '' ORDER BY `datum` ASC ");
+
+            $this->shop->view['arExportFormats'] = $this->arExportFormats;
+            $this->shop->view['arFileEncoding'] = $this->arFileEncoding;
+            $this->shop->view['arFieldFormats'] = $this->arFieldFormats;
+            $this->shop->view['arCronTypes'] = $this->arCronTypes;
+            $this->shop->view['fields'] = $this->fields;
+            $this->shop->view['strFields'] = $this->renderFields($this->shop->view['profil']);
+
+            return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_export/profil.phtml', false);
+
+        } // public function renderProfil($profil_id)
+
+        /**
+         * Zeichner die Felder des Profils
+         * @param $profil_data
+         */
+        function renderFields($profil_data)
+        {
+
+            if (!wpsg_isSizedArray($this->fields)) $this->loadFields();
+
+            $this->shop->view['arFieldFormats'] = $this->arFieldFormats;
+            $this->shop->view['fields'] = $this->fields;
+            $this->shop->view['profil'] = $profil_data;
+
+            return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_export/fields.phtml', false);
+
+        } // function renderFields($profil_data)
+
+        /**
+         * Gibt die Daten eines Profils zurÃŒck
+         * @return Array Array mit den Profildaten
+         * @param int $profil_id Die ID des zu ladenden Profils
+         */
+        public function loadProfil($profil_id)
+        {
+
+            $arReturn = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_EXPORTPROFILE."` WHERE `id` = '".wpsg_q($profil_id)."' ");
+
+            $arReturn['orderfilter'] = @unserialize($arReturn['orderfilter']);
+            if (!is_array($arReturn['orderfilter'])) $arReturn['orderfilter'] = array();
+
+            $arReturn['fields'] = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `profil_id` = '".wpsg_q($profil_id)."' ORDER BY `pos` ASC, `id` ASC ", "id");
+
+            if ($profil_id != wpsg_getInt($arReturn['id'])) throw new \Exception(__('Profil konnte nicht geladen werden.', 'wpsg'));
+
+            return $arReturn;
+
+        } // public function loadProfil($profil_id)
+
+        private function loadFields()
+        {
+
+            $this->fields = array(
+                5 => array(
+                    'name' => __('Allgemein', 'wpsg'),
+                    'fields' => array(
+                        'allgemein_empty' => __('Leer', 'wpsg'),
+                        //'allgemein_statisch' => __('Statisch', 'wpsg'),
+                        'allgemein_currency' => __('WÃ€hrung', 'wpsg')
+                    )
+                ),
+                10 => array(
+                    'name' => __('Bestellung', 'wpsg'),
+                    'fields' => array(
+                        'order_id' => __('BestellID', 'wpsg'),
+                        'order_cdate' => __('Erstellungsdatum', 'wpsg'),
+                        'order_onr' => __('Bestellnummer', 'wpsg'),
+                        'order_bemerkung' => __('Bemerkung Kunde', 'wpsg'),
+                        'order_price' => __('Bestellsumme', 'wpsg'),
+                        'order_price_netto' => __('Bestellsumme (Netto)', 'wpsg'),
+                        'order_shipping' => __('Versandkosten', 'wpsg'),
+                        'order_payment' => __('Kosten Bezahlmethode', 'wpsg'),
+                        'order_useragent' => __('UserAgent', 'wpsg'),
+                        'order_ip' => __('IP Adresse', 'wpsg'),
+
+                        'order_invoice_title' => __('Rechnungsadresse Anrede', 'wpsg'),
+                        'order_invoice_firma' => __('Rechnungsadresse Firma', 'wpsg'),
+                        'order_invoice_vorname' => __('Rechnunsadresse Vorname', 'wpsg'),
+                        'order_invoice_name' => __('Rechnungsadresse Name', 'wpsg'),
+                        'order_invoice_strasse' => __('Rechnungsadresse StraÃe (mit Hausnummer)', 'wpsg'),
+                        'order_invoice_strasse_strasse' => __('Rechnungsadresse StraÃe (ohne Hausnummer)', 'wpsg'),
+                        'order_invoice_strasse_nr' => __('Rechnungsadresse Hausnummer', 'wpsg'),
+                        'order_invoice_plz' => __('Rechnungsadresse PLZ', 'wpsg'),
+                        'order_invoice_ort' => __('Rechnungsadresse Ort', 'wpsg'),
+                        'order_invoice_land' => __('Rechnungsadresse Land (Name)', 'wpsg'),
+                        'order_invoice_land_krzl' => __('Rechnungsadresse Land (KÃŒrzel)', 'wpsg'),
+                        'order_invoice_tel' => __('Rechnungsadresse Telefon', 'wpsg'),
+                        'order_invoice_fax' => __('Rechnungsadresse Fax', 'wpsg'),
+
+                        'order_title' => __('Lieferadresse Anrede', 'wpsg'),
+                        'order_firma' => __('Lieferadresse Firma', 'wpsg'),
+                        'order_vorname' => __('Lieferadresse Vorname', 'wpsg'),
+                        'order_name' => __('Lieferadresse Name', 'wpsg'),
+                        'order_strasse' => __('Lieferadresse StraÃe (mit Hausnummer)', 'wpsg'),
                         'order_strasse_strasse' => __('Lieferadresse StraÃe (ohne Hausnummer)', 'wpsg'),
-						'order_strasse_nr' => __('Lieferadresse Hausnummer', 'wpsg'),
-						'order_plz' => __('Lieferadresse PLZ', 'wpsg'),
-						'order_ort' => __('Lieferadresse Ort', 'wpsg'),
-						'order_land' => __('Lieferadresse Land (Name)', 'wpsg'),
-						'order_land_krzl' => __('Lieferadresse Land (KÃŒrzel)', 'wpsg'),
-						
-						'order_payment_method' => __('Name der Zahlart', 'wpsg'),
-						'order_shipping_method' => __('Name der Versandart', 'wpsg'),
-						'order_count' => __('Anzahl Produkte', 'wpsg'),
-						'order_bname' => __('Name der Bank (Bankeinzug)', 'wpsg'),
-						'order_bblz' => __('BLZ der Bank (Bankeinzug)', 'wpsg'),
-						'order_bic' => __('BIC der Bank (Bankeinzug)', 'wpsg'),
-						'order_binhaber' => __('Kontoinhaber (Bankeinzug)', 'wpsg'),
-						'order_bnr' => __('Kontonummer (Bankeinzug)', 'wpsg'),
-						'order_iban' => __('IBAN Nummer (Bankeinzug)', 'wpsg'),						
-						'order_status' => __('Status der Bestellung', 'wpsg'),
-						'order_menge' => __('Anzahl an Artikeln', 'wpsg'),	
-						'order_weight' => __('Gesamtgewicht', 'wpsg')
-					)
-				),
-				20 => array(
-					'name' => __('Produkt', 'wpsg'),
-					'fields' => array(
-						'produkt_id' => __('ProduktID', 'wpsg'),
-						'produkt_index' => __('Position', 'wpsg'),
-						'produkt_name' => __('Produktname', 'wpsg'),
-						'product_url' => __('Produkt-URL', 'wpsg'),
-						'product_picture_url' => __('Produktbild-URL', 'wpsg'),
-						//'product_shippingprice' => __('Versandkosten', 'wpsg'),		
-						'produkt_typ' => __('Produkttyp', 'wpsg'),
-						'produkt_preis' => __('Produktpreis', 'wpsg'),
-						'produkt_preis_brutto' => __('Produktpreis (Brutto)', 'wpsg'),
-						'produkt_preis_netto' => __('Produktpreis (Netto)', 'wpsg'),
-						'product_preis_order' => __('Produktpreis aus Bestellung', 'wpsg'),
-						'product_preis_order_netto' => __('Produktpreis aus Bestellung (Netto)', 'wpsg'),
-						'produkt_mwst' => __('Mehrwertsteuer (SchlÃŒssel)', 'wpsg'),
-						'produkt_mwst_satz' => __('Mehrwertsteuer (Satz z.B. 19%)', 'wpsg'),
-						'produkt_mwst_value' => __('Mehrwertsteuer (Wert in â¬)', 'wpsg'),
-						'produkt_order_mwst_value' => __('Mehrwertsteuer (Wert in â¬ aus Bestellung)', 'wpsg'),
-						'produkt_feinheit' => __('FÃŒllmengeneinheit', 'wpsg'),
-						'produkt_fmenge' => __('FÃŒllmenge', 'wpsg'),
-						'produkt_beschreibung' => __('Beschreibung', 'wpsg'),
-						'produkt_weight' => __('Gewicht', 'wpsg'),		 
-						'produkt_anr' => __('Artikelnummer', 'wpsg'),
-						'produkt_menge' => __('Anzahl', 'wpsg'),
-						'produkt_ean' => __('EAN', 'wpsg'),
-						'produkt_gtin' => __('GTIN', 'wpsg')
-					)
-				),
-				30 => array(
-					'name' => __('Kunden', 'wpsg'),
-					'fields' => array(
-						'kunde_id' => __('KundenID', 'wpsg'),
-						'kunde_nr' => __('Kundennummer', 'wpsg'),
-						'kunde_title' => __('Anrede', 'wpsg'),
-						'kunde_firma' => __('Firma', 'wpsg'),
-						'kunde_vorname' => __('Vorname', 'wpsg'),
-						'kunde_name' => __('Name', 'wpsg'),
-						'kunde_strasse' => __('StraÃe (mit Hausnummer)', 'wpsg'),
+                        'order_strasse_nr' => __('Lieferadresse Hausnummer', 'wpsg'),
+                        'order_plz' => __('Lieferadresse PLZ', 'wpsg'),
+                        'order_ort' => __('Lieferadresse Ort', 'wpsg'),
+                        'order_land' => __('Lieferadresse Land (Name)', 'wpsg'),
+                        'order_land_krzl' => __('Lieferadresse Land (KÃŒrzel)', 'wpsg'),
+
+                        'order_payment_method' => __('Name der Zahlart', 'wpsg'),
+                        'order_shipping_method' => __('Name der Versandart', 'wpsg'),
+                        'order_count' => __('Anzahl Produkte', 'wpsg'),
+                        'order_bname' => __('Name der Bank (Bankeinzug)', 'wpsg'),
+                        'order_bblz' => __('BLZ der Bank (Bankeinzug)', 'wpsg'),
+                        'order_bic' => __('BIC der Bank (Bankeinzug)', 'wpsg'),
+                        'order_binhaber' => __('Kontoinhaber (Bankeinzug)', 'wpsg'),
+                        'order_bnr' => __('Kontonummer (Bankeinzug)', 'wpsg'),
+                        'order_iban' => __('IBAN Nummer (Bankeinzug)', 'wpsg'),
+                        'order_status' => __('Status der Bestellung', 'wpsg'),
+                        'order_menge' => __('Anzahl an Artikeln', 'wpsg'),
+                        'order_weight' => __('Gesamtgewicht', 'wpsg')
+                    )
+                ),
+                20 => array(
+                    'name' => __('Produkt', 'wpsg'),
+                    'fields' => array(
+                        'produkt_id' => __('ProduktID', 'wpsg'),
+                        'produkt_index' => __('Position', 'wpsg'),
+                        'produkt_name' => __('Produktname', 'wpsg'),
+                        'product_url' => __('Produkt-URL', 'wpsg'),
+                        'product_picture_url' => __('Produktbild-URL', 'wpsg'),
+                        //'product_shippingprice' => __('Versandkosten', 'wpsg'),		
+                        'produkt_typ' => __('Produkttyp', 'wpsg'),
+                        'produkt_preis' => __('Produktpreis', 'wpsg'),
+                        'produkt_preis_brutto' => __('Produktpreis (Brutto)', 'wpsg'),
+                        'produkt_preis_netto' => __('Produktpreis (Netto)', 'wpsg'),
+                        'product_preis_order' => __('Produktpreis aus Bestellung', 'wpsg'),
+                        'product_preis_order_netto' => __('Produktpreis aus Bestellung (Netto)', 'wpsg'),
+                        'produkt_mwst' => __('Mehrwertsteuer (SchlÃŒssel)', 'wpsg'),
+                        'produkt_mwst_satz' => __('Mehrwertsteuer (Satz z.B. 19%)', 'wpsg'),
+                        'produkt_mwst_value' => __('Mehrwertsteuer (Wert in â¬)', 'wpsg'),
+                        'produkt_order_mwst_value' => __('Mehrwertsteuer (Wert in â¬ aus Bestellung)', 'wpsg'),
+                        'produkt_feinheit' => __('FÃŒllmengeneinheit', 'wpsg'),
+                        'produkt_fmenge' => __('FÃŒllmenge', 'wpsg'),
+                        'produkt_beschreibung' => __('Beschreibung', 'wpsg'),
+                        'produkt_longdescription' => __('Langtext', 'wpsg'),
+                        'produkt_moreinfos' => __('ZusÃ€tzliche Informationen', 'wpsg'),
+                        'produkt_moreinfos2' => __('Lieferumfang', 'wpsg'),
+                        'produkt_weight' => __('Gewicht', 'wpsg'),
+                        'produkt_anr' => __('Artikelnummer', 'wpsg'),
+                        'produkt_menge' => __('Anzahl', 'wpsg'),
+                        'produkt_ean' => __('EAN', 'wpsg'),
+                        'produkt_gtin' => __('GTIN', 'wpsg')
+                    )
+                ),
+                30 => array(
+                    'name' => __('Kunden', 'wpsg'),
+                    'fields' => array(
+                        'kunde_id' => __('KundenID', 'wpsg'),
+                        'kunde_nr' => __('Kundennummer', 'wpsg'),
+                        'kunde_title' => __('Anrede', 'wpsg'),
+                        'kunde_firma' => __('Firma', 'wpsg'),
+                        'kunde_vorname' => __('Vorname', 'wpsg'),
+                        'kunde_name' => __('Name', 'wpsg'),
+                        'kunde_strasse' => __('StraÃe (mit Hausnummer)', 'wpsg'),
                         'kunde_strasse_strasse' => __('StraÃe (ohne Hausnummer)', 'wpsg'),
-						'kunde_strasse_nr' => __('Hausnummer', 'wpsg'),
-						'kunde_ort' => __('Ort', 'wpsg'),
-						'kunde_plz' => __('PLZ', 'wpsg'),
-						'kunde_land' => __('Land (Name)', 'wpsg'),
-						'kunde_land_krzl' => __('Land (KÃŒrzel)', 'wpsg'),
-						'kunde_tel' => __('Telefon', 'wpsg'),
-						'kunde_fax' => __('Faxnummer', 'wpsg'),
-						'kunde_email' => __('E-Mail', 'wpsg'),
-						'kunde_ustid' => __('Umsatzsteuernummer', 'wpsg'),
-						'kunde_geb' => __('Geburtsdatum', 'wpsg')					
-					)
-				),	
-			);
-			
-			if ($this->shop->hasMod('wpsg_mod_stock')) {
+                        'kunde_strasse_nr' => __('Hausnummer', 'wpsg'),
+                        'kunde_ort' => __('Ort', 'wpsg'),
+                        'kunde_plz' => __('PLZ', 'wpsg'),
+                        'kunde_land' => __('Land (Name)', 'wpsg'),
+                        'kunde_land_krzl' => __('Land (KÃŒrzel)', 'wpsg'),
+                        'kunde_tel' => __('Telefon', 'wpsg'),
+                        'kunde_fax' => __('Faxnummer', 'wpsg'),
+                        'kunde_email' => __('E-Mail', 'wpsg'),
+                        'kunde_ustid' => __('Umsatzsteuernummer', 'wpsg'),
+                        'kunde_geb' => __('Geburtsdatum', 'wpsg')
+                    )
+                ),
+            );
+
+            if ($this->shop->hasMod('wpsg_mod_stock')) {
 
                 $this->fields[20]['fields']['produkt_stock'] = __('Lagerbestand', 'wpsg');
-			    $this->fields[20]['fields']['product_stock_state'] = __('Lagerstatus', 'wpsg');
-			    
-            }
-			
-			// AboProdukte
-			if ($this->shop->hasMod('wpsg_mod_abo'))
-			{
-				
-				$this->field[12] = array(
-					'name' => __('Abo', 'wpsg'),
-					'fields' => array(
-						'startdate' => __('Abobeginn', 'wpsg'),
-						'enddate' => __('Aboende', 'wpsg'), 
-						'runtime' => __('Laufzeit', 'wpsg')
-					)	
-						
-				);
-				
-			}
-			
-			// Rechnungen
-			if ($this->shop->hasMod('wpsg_mod_rechnungen'))
-			{
-				
-				$this->fields[11] = array(
-					'name' => __('Rechnung', 'wpsg'),
-					'fields' => array(
-						'rechnung_nr' => __('Rechnungsnummer', 'wpsg'),
-						'gutschrift_nr' => __('Rechnungskorrekturnummer', 'wpsg'),
-						'rdatum' => __('Datum der Rechnung/Rechnungskorrektur', 'wpsg')
-					) 
-				);
-				
-			}
-			
-			// Gutscheinmodul
-			if ($this->shop->hasMod('wpsg_mod_gutschein'))
-			{
-				
-				$this->fields[10]['fields']['order_gutschein'] = __('Gutscheinnummer', 'wpsg');
-				
-			}
-			
-			// Bestellvariablen 
-			if ($this->shop->hasMod('wpsg_mod_ordervars'))
-			{
-				
-				$arOV = array();
-				$arOrderVars = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_ORDERVARS."` WHERE `deleted` != '1' ORDER BY `pos` ASC, `id` ASC ");
-				
-				foreach ($arOrderVars as $ov)
-				{
-					
-					$arOV['ov_'.$ov['id']] = $ov['name'];	
-					
-				}
-				
-				if (is_array($arOV) && sizeof($arOV) > 0)
-				{
-					
-					$arOV = array(
-						'name' => __('Bestellvariablen', 'wpsg'),
-						'fields' => $arOV
-					);
-					
-					$this->fields[12] = $arOV;
-					
-				}
-				
-			}			
-			
-			/* Produktvariablen */ 
-			if ($this->shop->hasMod('wpsg_mod_productvars'))
-			{
-							
-				$arPV = array();
-				$arProduktVars = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_PRODUCTS_VARS."` ORDER BY `name` ");
-				
-				foreach ($arProduktVars as $pv)
-				{
-					
-					$arPV['pv_'.$pv['id']] = $pv['name'];
-					
-				}
-				
-				if (is_array($arPV) && sizeof($arPV) > 0)
-				{
-					
-					$arPV = array(
-						'name' => __('Produktvariablen', 'wpsg'),
-						'fields' => $arPV
-					);
-					
-					$this->fields[21] = $arPV;
-					
-				}
-				
-			} 
-			
-			/* Produktattribute */
-			if ($this->shop->hasMod('wpsg_mod_produktattribute'))
-			{
-				
-				$arPA = array();
-				$arProduktAttribute = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_AT."` ORDER BY `name` ");
-				
-				foreach ($arProduktAttribute as $pa)
-				{
-					
-					$arPA['pa_'.$pa['id']] = $pa['name'];
-					
-				}
-				
-				if (is_array($arPA) && sizeof($arPA) > 0)
-				{
-					
-					$arPA = array(
-						'name' => __('Produktattribute', 'wpsg'),
-						'fields' => $arPA
-					);
-					
-					$this->fields[22] = $arPA;
-					
-				}
-				
-			}
-								
-			/* Kundenvariablen */
-			$kv = $this->shop->loadPflichtFeldDaten();
-			if (is_array($kv) && sizeof($kv) > 0 && is_array($kv['custom']) && sizeof($kv['custom']) > 0)
-			{
-				
-				$arKV = array(); 
-				foreach ($kv['custom'] as $kv_key => $kv)
-				{
-					
-					$arKV['kv_'.$kv_key] = $kv['name'];
-					
-				}
-				
-				if (is_array($arKV) && sizeof($arKV) > 0)
-				{
-					
-					$arKV = array(
-						'name' => __('Kundenvariablen', 'wpsg'),
-						'fields' => $arKV
-					);
-					
-					$this->fields[31] = $arKV;
-					
-				}
-				
-			}
-			
-			$this->shop->callMods('wpsg_mod_export_loadFields', array(&$this->fields));
-			
-			ksort($this->fields);
-			
-		}
-		
-		public function getValue($f, $profil_separator, $o_id, $p_id = false, $product_index = 1, $productkey = false, $order_product_id = false, $customer_id = false)
-		{
-			
-			$field_value = $f['value_key'];
-			
-			$cache_key = $o_id.'_'.$p_id.'_'.$product_index.'_'.$productkey.'_'.$order_product_id.'_'.$customer_id;
-			
-			// Hier werden die Ergebnisse gespeichert
-			if (array_key_exists($cache_key, $this->arCache))
-			{
-				
-				$order = $this->arCache[$cache_key]['order'];
-				$produkt = $this->arCache[$cache_key]['produkt'];
-				$kunde = $this->arCache[$cache_key]['kunde'];
-								
-			}
-			else
-			{
-			
-				$order = $this->db->fetchRow("
+                $this->fields[20]['fields']['product_stock_state'] = __('Lagerstatus', 'wpsg');
+
+            }
+
+            // AboProdukte
+            if ($this->shop->hasMod('wpsg_mod_abo'))
+            {
+
+                $this->field[12] = array(
+                    'name' => __('Abo', 'wpsg'),
+                    'fields' => array(
+                        'startdate' => __('Abobeginn', 'wpsg'),
+                        'enddate' => __('Aboende', 'wpsg'),
+                        'runtime' => __('Laufzeit', 'wpsg')
+                    )
+
+                );
+
+            }
+
+            // Rechnungen
+            if ($this->shop->hasMod('wpsg_mod_rechnungen'))
+            {
+
+                $this->fields[11] = array(
+                    'name' => __('Rechnung', 'wpsg'),
+                    'fields' => array(
+                        'rechnung_nr' => __('Rechnungsnummer', 'wpsg'),
+                        'gutschrift_nr' => __('Rechnungskorrekturnummer', 'wpsg'),
+                        'rdatum' => __('Datum der Rechnung/Rechnungskorrektur', 'wpsg')
+                    )
+                );
+
+            }
+
+            // Gutscheinmodul
+            if ($this->shop->hasMod('wpsg_mod_gutschein'))
+            {
+
+                $this->fields[10]['fields']['order_gutschein'] = __('Gutscheinnummer', 'wpsg');
+
+            }
+
+            // Bestellvariablen 
+            if ($this->shop->hasMod('wpsg_mod_ordervars'))
+            {
+
+                $arOV = array();
+                $arOrderVars = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_ORDERVARS."` WHERE `deleted` != '1' ORDER BY `pos` ASC, `id` ASC ");
+
+                foreach ($arOrderVars as $ov)
+                {
+
+                    $arOV['ov_'.$ov['id']] = $ov['name'];
+
+                }
+
+                if (is_array($arOV) && sizeof($arOV) > 0)
+                {
+
+                    $arOV = array(
+                        'name' => __('Bestellvariablen', 'wpsg'),
+                        'fields' => $arOV
+                    );
+
+                    $this->fields[12] = $arOV;
+
+                }
+
+            }
+
+            /* Produktvariablen */
+            if ($this->shop->hasMod('wpsg_mod_productvars'))
+            {
+
+                $arPV = array();
+                $arProduktVars = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_PRODUCTS_VARS."` ORDER BY `name` ");
+
+                foreach ($arProduktVars as $pv)
+                {
+
+                    $arPV['pv_'.$pv['id']] = $pv['name'];
+
+                }
+
+                if (is_array($arPV) && sizeof($arPV) > 0)
+                {
+
+                    $arPV = array(
+                        'name' => __('Produktvariablen', 'wpsg'),
+                        'fields' => $arPV
+                    );
+
+                    $this->fields[21] = $arPV;
+
+                }
+
+            }
+
+            /* Produktattribute */
+            if ($this->shop->hasMod('wpsg_mod_produktattribute'))
+            {
+
+                $arPA = array();
+                $arProduktAttribute = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_AT."` ORDER BY `name` ");
+
+                foreach ($arProduktAttribute as $pa)
+                {
+
+                    $arPA['pa_'.$pa['id']] = $pa['name'];
+
+                }
+
+                if (is_array($arPA) && sizeof($arPA) > 0)
+                {
+
+                    $arPA = array(
+                        'name' => __('Produktattribute', 'wpsg'),
+                        'fields' => $arPA
+                    );
+
+                    $this->fields[22] = $arPA;
+
+                }
+
+            }
+
+            /* Kundenvariablen */
+            $kv = $this->shop->loadPflichtFeldDaten();
+            if (is_array($kv) && sizeof($kv) > 0 && is_array($kv['custom']) && sizeof($kv['custom']) > 0)
+            {
+
+                $arKV = array();
+                foreach ($kv['custom'] as $kv_key => $kv)
+                {
+
+                    $arKV['kv_'.$kv_key] = $kv['name'];
+
+                }
+
+                if (is_array($arKV) && sizeof($arKV) > 0)
+                {
+
+                    $arKV = array(
+                        'name' => __('Kundenvariablen', 'wpsg'),
+                        'fields' => $arKV
+                    );
+
+                    $this->fields[31] = $arKV;
+
+                }
+
+            }
+
+            $this->shop->callMods('wpsg_mod_export_loadFields', array(&$this->fields));
+
+            ksort($this->fields);
+
+        }
+
+        public function getValue($f, $profil_separator, $o_id, $p_id = false, $product_index = 1, $productkey = false, $order_product_id = false, $customer_id = false)
+        {
+
+            $field_value = $f['value_key'];
+
+            $cache_key = $o_id.'_'.$p_id.'_'.$product_index.'_'.$productkey.'_'.$order_product_id.'_'.$customer_id;
+
+            // Hier werden die Ergebnisse gespeichert
+            if (array_key_exists($cache_key, $this->arCache))
+            {
+
+                $order = $this->arCache[$cache_key]['order'];
+                $produkt = $this->arCache[$cache_key]['produkt'];
+                $kunde = $this->arCache[$cache_key]['kunde'];
+
+            }
+            else
+            {
+
+                $order = $this->db->fetchRow("
 					SELECT 
 						O.*
